diff --git a/base/util/src/netscape/security/pkcs/PKCS9Attribute.java b/base/util/src/netscape/security/pkcs/PKCS9Attribute.java
index 398fc0174bb797ee5d90a5083bc1f3548d4e504b..703f84cb946056ab8b0476c32e3935fbe2860b83 100644
--- a/base/util/src/netscape/security/pkcs/PKCS9Attribute.java
+++ b/base/util/src/netscape/security/pkcs/PKCS9Attribute.java
@@ -758,116 +758,114 @@ public class PKCS9Attribute implements DerEncoder {
      * <code>PrintableString</code>s, without checking whether they should be encoded as <code>T61String</code>s.
      */
     public void derEncode(OutputStream out) throws IOException {
-        DerOutputStream temp = new DerOutputStream();
-        temp.putOID(getOID());
-        switch (index) {
-        case 1: // email address
-        case 2: // unstructured name
-        { // open scope
-            String[] values = (String[]) value;
-            DerOutputStream[] temps = new
-                    DerOutputStream[values.length];
-
-            for (int i = 0; i < values.length; i++) {
-                temps[i] = new DerOutputStream();
-
-                temps[i].putIA5String(values[i]);
+        try (DerOutputStream temp = new DerOutputStream(); DerOutputStream temp2 = new DerOutputStream();
+                DerOutputStream derOut = new DerOutputStream()) {
+            temp.putOID(getOID());
+            switch (index) {
+            case 1: // email address
+            case 2: // unstructured name
+            { // open scope
+                String[] values = (String[]) value;
+                DerOutputStream[] temps = new
+                        DerOutputStream[values.length];
+
+                for (int i = 0; i < values.length; i++) {
+                    temps[i] = new DerOutputStream();
+
+                    temps[i].putIA5String(values[i]);
+                }
+                temp.putOrderedSetOf(DerValue.tag_Set, temps);
+            } // close scope
+                break;
+
+            case 3: // content type
+            {
+                temp2.putOID((ObjectIdentifier) value);
+                temp.write(DerValue.tag_Set, temp2.toByteArray());
             }
-            temp.putOrderedSetOf(DerValue.tag_Set, temps);
-        } // close scope
-            break;
-
-        case 3: // content type
-        {
-            DerOutputStream temp2 = new DerOutputStream();
-            temp2.putOID((ObjectIdentifier) value);
-            temp.write(DerValue.tag_Set, temp2.toByteArray());
-        }
-            break;
-
-        case 4: // message digest
-        {
-            DerOutputStream temp2 = new DerOutputStream();
-            temp2.putOctetString((byte[]) value);
-            temp.write(DerValue.tag_Set, temp2.toByteArray());
-        }
-            break;
-
-        case 5: // signing time
-        {
-            DerOutputStream temp2 = new DerOutputStream();
-            temp2.putUTCTime((Date) value);
-            temp.write(DerValue.tag_Set, temp2.toByteArray());
-        }
-            break;
-
-        case 6: // countersignature
-            temp.putOrderedSetOf(DerValue.tag_Set, (DerEncoder[]) value);
-            break;
+                break;
 
-        case 7: // challenge password
-        {
-            DerOutputStream temp2 = new DerOutputStream();
-            temp2.putPrintableString((String) value);
-            temp.write(DerValue.tag_Set, temp2.toByteArray());
-        }
-            break;
+            case 4: // message digest
+            {
+                temp2.putOctetString((byte[]) value);
+                temp.write(DerValue.tag_Set, temp2.toByteArray());
+            }
+                break;
 
-        case 8: // unstructured address
-        { // open scope
-            String[] values = (String[]) value;
-            DerOutputStream[] temps = new
-                    DerOutputStream[values.length];
+            case 5: // signing time
+            {
+                temp2.putUTCTime((Date) value);
+                temp.write(DerValue.tag_Set, temp2.toByteArray());
+            }
+                break;
 
-            for (int i = 0; i < values.length; i++) {
-                temps[i] = new DerOutputStream();
+            case 6: // countersignature
+                temp.putOrderedSetOf(DerValue.tag_Set, (DerEncoder[]) value);
+                break;
 
-                temps[i].putPrintableString(values[i]);
+            case 7: // challenge password
+            {
+                temp2.putPrintableString((String) value);
+                temp.write(DerValue.tag_Set, temp2.toByteArray());
             }
-            temp.putOrderedSetOf(DerValue.tag_Set, temps);
-        } // close scope
-            break;
-
-        case 9: // extended-certificate attribute -- not
-            // supported
-            throw new IOException("PKCS9 extended-certificate " +
-                    "attribute not supported.");
-
-        case 10: // IssuerAndSerialNumber attribute -- not
-            // supported
-            throw new IOException("PKCS9 IssuerAndSerialNumber " +
-                    "attribute not supported.");
-
-        case 11: // passwordCheck attribute -- not
-            // supported
-            throw new IOException("PKCS9 passwordCheck " +
-                    "attribute not supported.");
-        case 12: // PublicKey attribute -- not
-            // supported
-            throw new IOException("PKCS9 PublicKey " +
-                    "attribute not supported.");
-        case 13: // SigningDescription attribute -- not
-            // supported
-            throw new IOException("PKCS9 SigningDescription " +
-                    "attribute not supported.");
-        case 14: // ExtensionRequest attribute
-            try {
-                DerOutputStream temp2 = new DerOutputStream();
-                //temp2.putSequence((CertificateExtensions) value);
-                ((CertificateExtensions) value).encode(temp2);
-                temp.write(DerValue.tag_Sequence, temp2.toByteArray());
-            } catch (CertificateException e) {
-                throw new IOException("PKCS9 extension attributes not encoded");
+                break;
+
+            case 8: // unstructured address
+            { // open scope
+                String[] values = (String[]) value;
+                DerOutputStream[] temps = new
+                        DerOutputStream[values.length];
+
+                for (int i = 0; i < values.length; i++) {
+                    temps[i] = new DerOutputStream();
+
+                    temps[i].putPrintableString(values[i]);
+                }
+                temp.putOrderedSetOf(DerValue.tag_Set, temps);
+            } // close scope
+                break;
+
+            case 9: // extended-certificate attribute -- not
+                // supported
+                throw new IOException("PKCS9 extended-certificate " +
+                        "attribute not supported.");
+
+            case 10: // IssuerAndSerialNumber attribute -- not
+                // supported
+                throw new IOException("PKCS9 IssuerAndSerialNumber " +
+                        "attribute not supported.");
+
+            case 11: // passwordCheck attribute -- not
+                // supported
+                throw new IOException("PKCS9 passwordCheck " +
+                        "attribute not supported.");
+            case 12: // PublicKey attribute -- not
+                // supported
+                throw new IOException("PKCS9 PublicKey " +
+                        "attribute not supported.");
+            case 13: // SigningDescription attribute -- not
+                // supported
+                throw new IOException("PKCS9 SigningDescription " +
+                        "attribute not supported.");
+            case 14: // ExtensionRequest attribute
+                try {
+                    //temp2.putSequence((CertificateExtensions) value);
+                    ((CertificateExtensions) value).encode(temp2);
+                    temp.write(DerValue.tag_Sequence, temp2.toByteArray());
+                } catch (CertificateException e) {
+                    throw new IOException("PKCS9 extension attributes not encoded");
+                }
+
+                // break unnecessary
+            default: // can't happen
             }
 
-            // break unnecessary
-        default: // can't happen
-        }
-
-        DerOutputStream derOut = new DerOutputStream();
-        derOut.write(DerValue.tag_Sequence, temp.toByteArray());
+            derOut.write(DerValue.tag_Sequence, temp.toByteArray());
 
-        out.write(derOut.toByteArray());
+            out.write(derOut.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
 
     }
 
diff --git a/base/util/src/netscape/security/pkcs/PKCS9Attributes.java b/base/util/src/netscape/security/pkcs/PKCS9Attributes.java
index 35996b4b68b0e11483c10a6daa93696e5e517601..7777962cb397a9640e020909fd1aef7251c59061 100644
--- a/base/util/src/netscape/security/pkcs/PKCS9Attributes.java
+++ b/base/util/src/netscape/security/pkcs/PKCS9Attributes.java
@@ -191,12 +191,15 @@ public class PKCS9Attributes {
     }
 
     private byte[] generateDerEncoding() throws IOException {
-        DerOutputStream out = new DerOutputStream();
-        Object[] attribVals = attributes.values().toArray();
+        try (DerOutputStream out = new DerOutputStream()) {
+            Object[] attribVals = attributes.values().toArray();
 
-        out.putOrderedSetOf(DerValue.tag_SetOf,
-                castToDerEncoder(attribVals));
-        return out.toByteArray();
+            out.putOrderedSetOf(DerValue.tag_SetOf,
+                    castToDerEncoder(attribVals));
+            return out.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/pkcs/SignerInfo.java b/base/util/src/netscape/security/pkcs/SignerInfo.java
index 794033c8774fb8b04558322bb1c8218231f25821..83b77bef1b74d7aad5e34f15cfc6105b0386f349 100644
--- a/base/util/src/netscape/security/pkcs/SignerInfo.java
+++ b/base/util/src/netscape/security/pkcs/SignerInfo.java
@@ -148,31 +148,34 @@ public class SignerInfo implements DerEncoder {
      * @exception IOException on encoding error.
      */
     public void derEncode(OutputStream out) throws IOException {
-        DerOutputStream seq = new DerOutputStream();
-        seq.putInteger(version);
-        DerOutputStream issuerAndSerialNumber = new DerOutputStream();
-        issuerName.encode(issuerAndSerialNumber);
-        issuerAndSerialNumber.putInteger(certificateSerialNumber);
-        seq.write(DerValue.tag_Sequence, issuerAndSerialNumber);
+        try (DerOutputStream tmp = new DerOutputStream()) {
+            DerOutputStream seq = new DerOutputStream();
+            seq.putInteger(version);
+            DerOutputStream issuerAndSerialNumber = new DerOutputStream();
+            issuerName.encode(issuerAndSerialNumber);
+            issuerAndSerialNumber.putInteger(certificateSerialNumber);
+            seq.write(DerValue.tag_Sequence, issuerAndSerialNumber);
 
-        digestAlgorithmId.encode(seq);
+            digestAlgorithmId.encode(seq);
 
-        // encode authenticated attributes if there are any
-        if (authenticatedAttributes != null)
-            authenticatedAttributes.encode((byte) 0xA0, seq);
+            // encode authenticated attributes if there are any
+            if (authenticatedAttributes != null)
+                authenticatedAttributes.encode((byte) 0xA0, seq);
 
-        digestEncryptionAlgorithmId.encode(seq);
+            digestEncryptionAlgorithmId.encode(seq);
 
-        seq.putOctetString(encryptedDigest);
+            seq.putOctetString(encryptedDigest);
 
-        // encode unauthenticated attributes if there are any
-        if (unauthenticatedAttributes != null)
-            unauthenticatedAttributes.encode((byte) 0xA1, seq);
+            // encode unauthenticated attributes if there are any
+            if (unauthenticatedAttributes != null)
+                unauthenticatedAttributes.encode((byte) 0xA1, seq);
 
-        DerOutputStream tmp = new DerOutputStream();
-        tmp.write(DerValue.tag_Sequence, seq);
+            tmp.write(DerValue.tag_Sequence, seq);
 
-        out.write(tmp.toByteArray());
+            out.write(tmp.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     public X509Certificate getCertificate(PKCS7 block)
diff --git a/base/util/src/netscape/security/provider/DSA.java b/base/util/src/netscape/security/provider/DSA.java
index 9403475e0b3ab5cf0b19dd34b95731de3f1f1c25..5599ae33bceeb3b1d2e18254111f95e20b6a6710 100644
--- a/base/util/src/netscape/security/provider/DSA.java
+++ b/base/util/src/netscape/security/provider/DSA.java
@@ -163,8 +163,7 @@ public final class DSA extends Signature {
         BigInt rAsBigInt = new BigInt(r.toByteArray());
         BigInt sAsBigInt = new BigInt(s.toByteArray());
 
-        try {
-            DerOutputStream outseq = new DerOutputStream(100);
+        try (DerOutputStream outseq = new DerOutputStream(100)) {
             outseq.putInteger(rAsBigInt);
             outseq.putInteger(sAsBigInt);
             DerValue result = new DerValue(DerValue.tag_Sequence,
diff --git a/base/util/src/netscape/security/provider/DSAParameters.java b/base/util/src/netscape/security/provider/DSAParameters.java
index d22ab10fc13784212d420b54b82acd57f8bdfe2c..0d3f16ef64f08db6cf04f3be3f95d66170405dd1 100755
--- a/base/util/src/netscape/security/provider/DSAParameters.java
+++ b/base/util/src/netscape/security/provider/DSAParameters.java
@@ -103,14 +103,17 @@ public class DSAParameters extends AlgorithmParametersSpi {
     }
 
     protected byte[] engineGetEncoded() throws IOException {
-        DerOutputStream out = new DerOutputStream();
-        DerOutputStream bytes = new DerOutputStream();
+        try (DerOutputStream out = new DerOutputStream()) {
+            DerOutputStream bytes = new DerOutputStream();
 
-        bytes.putInteger(new BigInt(p.toByteArray()));
-        bytes.putInteger(new BigInt(q.toByteArray()));
-        bytes.putInteger(new BigInt(g.toByteArray()));
-        out.write(DerValue.tag_Sequence, bytes);
-        return out.toByteArray();
+            bytes.putInteger(new BigInt(p.toByteArray()));
+            bytes.putInteger(new BigInt(q.toByteArray()));
+            bytes.putInteger(new BigInt(g.toByteArray()));
+            out.write(DerValue.tag_Sequence, bytes);
+            return out.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     protected byte[] engineGetEncoded(String encodingMethod)
diff --git a/base/util/src/netscape/security/provider/RSAPublicKey.java b/base/util/src/netscape/security/provider/RSAPublicKey.java
index bd5aa2fe4f028e0b801babe6a4dd5e1a33610f2a..b3c10f56274cb98c4cd135fddaa6b17e03b068d5 100644
--- a/base/util/src/netscape/security/provider/RSAPublicKey.java
+++ b/base/util/src/netscape/security/provider/RSAPublicKey.java
@@ -73,9 +73,7 @@ public final class RSAPublicKey extends X509Key implements Serializable {
         this.publicExponent = publicExponent;
         this.algid = new AlgorithmId(ALGORITHM_OID);
 
-        try {
-            DerOutputStream out = new DerOutputStream();
-
+        try (DerOutputStream out = new DerOutputStream()) {
             out.putInteger(modulus);
             out.putInteger(publicExponent);
             key = (new DerValue(DerValue.tag_Sequence,
diff --git a/base/util/src/netscape/security/x509/AVA.java b/base/util/src/netscape/security/x509/AVA.java
index 534f7c212094bf3423423be7248e11da2229ae84..d56bd95cadc4416053846198fedd0938efbb1e38 100644
--- a/base/util/src/netscape/security/x509/AVA.java
+++ b/base/util/src/netscape/security/x509/AVA.java
@@ -232,13 +232,16 @@ public final class AVA implements DerEncoder {
      * @exception IOException on encoding error.
      */
     public void derEncode(OutputStream out) throws IOException {
-        DerOutputStream tmp = new DerOutputStream();
-        DerOutputStream tmp2 = new DerOutputStream();
+        try (DerOutputStream tmp2 = new DerOutputStream()) {
+            DerOutputStream tmp = new DerOutputStream();
 
-        tmp.putOID(oid);
-        value.encode(tmp);
-        tmp2.write(DerValue.tag_Sequence, tmp);
-        out.write(tmp2.toByteArray());
+            tmp.putOID(oid);
+            value.encode(tmp);
+            tmp2.write(DerValue.tag_Sequence, tmp);
+            out.write(tmp2.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/AlgIdDSA.java b/base/util/src/netscape/security/x509/AlgIdDSA.java
index ed2a73de0e362b81e41bb60fcab1f985697470ca..30777dcb6f418974fdb0c51dd0e4b15192742dc6 100644
--- a/base/util/src/netscape/security/x509/AlgIdDSA.java
+++ b/base/util/src/netscape/security/x509/AlgIdDSA.java
@@ -130,12 +130,14 @@ public final class AlgIdDSA extends AlgorithmId implements DSAParams {
      */
     private void initializeParams()
             throws IOException {
-        DerOutputStream out = new DerOutputStream();
-
-        out.putInteger(new BigInt(p.toByteArray()));
-        out.putInteger(new BigInt(q.toByteArray()));
-        out.putInteger(new BigInt(g.toByteArray()));
-        params = new DerValue(DerValue.tag_Sequence, out.toByteArray());
+        try (DerOutputStream out = new DerOutputStream()) {
+            out.putInteger(new BigInt(p.toByteArray()));
+            out.putInteger(new BigInt(q.toByteArray()));
+            out.putInteger(new BigInt(g.toByteArray()));
+            params = new DerValue(DerValue.tag_Sequence, out.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/AlgorithmId.java b/base/util/src/netscape/security/x509/AlgorithmId.java
index a027c19cc2cd6192ddfabe267f3dd15604412ba0..eb2c0413fd56f6a017229b58004a4e322d9519e9 100644
--- a/base/util/src/netscape/security/x509/AlgorithmId.java
+++ b/base/util/src/netscape/security/x509/AlgorithmId.java
@@ -227,16 +227,18 @@ public class AlgorithmId implements Serializable, DerEncoder {
      * @exception IOException on encoding error.
      */
     public void derEncode(OutputStream out) throws IOException {
-        DerOutputStream bytes = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
-
-        bytes.putOID(algid);
-        if (params == null)
-            bytes.putNull();
-        else
-            bytes.putDerValue(params);
-        tmp.write(DerValue.tag_Sequence, bytes);
-        out.write(tmp.toByteArray());
+        try (DerOutputStream tmp = new DerOutputStream()) {
+            DerOutputStream bytes = new DerOutputStream();
+            bytes.putOID(algid);
+            if (params == null)
+                bytes.putNull();
+            else
+                bytes.putDerValue(params);
+            tmp.write(DerValue.tag_Sequence, bytes);
+            out.write(tmp.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     // XXXX cleaning required
@@ -244,16 +246,19 @@ public class AlgorithmId implements Serializable, DerEncoder {
      * Returns the DER-encoded X.509 AlgorithmId as a byte array.
      */
     public final byte[] encode() throws IOException {
-        DerOutputStream out = new DerOutputStream();
-        DerOutputStream bytes = new DerOutputStream();
+        try (DerOutputStream out = new DerOutputStream()) {
+            DerOutputStream bytes = new DerOutputStream();
 
-        bytes.putOID(algid);
-        if (params == null)
-            bytes.putNull();
-        else
-            bytes.putDerValue(params);
-        out.write(DerValue.tag_Sequence, bytes);
-        return out.toByteArray();
+            bytes.putOID(algid);
+            if (params == null)
+                bytes.putNull();
+            else
+                bytes.putDerValue(params);
+            out.write(DerValue.tag_Sequence, bytes);
+            return out.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/Attribute.java b/base/util/src/netscape/security/x509/Attribute.java
index 760d0a805e2b40b5eaa6def0164af0b4943591c9..6f57213e649e3d6d6e4a71516122c13d0211e302 100644
--- a/base/util/src/netscape/security/x509/Attribute.java
+++ b/base/util/src/netscape/security/x509/Attribute.java
@@ -229,38 +229,44 @@ public final class Attribute implements Serializable, DerEncoder {
     //encode the attribute object
     private void encodeThis(OutputStream out)
             throws IOException {
-        DerOutputStream tmp = new DerOutputStream();
-        DerOutputStream tmp2 = new DerOutputStream();
+        try (DerOutputStream tmp2 = new DerOutputStream()) {
+            DerOutputStream tmp = new DerOutputStream();
 
-        tmp.putOID(oid);
-        encodeValueSet(tmp);
-        tmp2.write(DerValue.tag_Sequence, tmp);
-        out.write(tmp2.toByteArray());
+            tmp.putOID(oid);
+            encodeValueSet(tmp);
+            tmp2.write(DerValue.tag_Sequence, tmp);
+            out.write(tmp2.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     //encode the attribute object
     private void encodeValueSet(OutputStream out)
             throws IOException {
-        DerOutputStream tmp = new DerOutputStream();
-        DerOutputStream tmp2 = new DerOutputStream();
+        try (DerOutputStream tmp2 = new DerOutputStream()) {
+            DerOutputStream tmp = new DerOutputStream();
 
-        //get the attribute converter
-        AVAValueConverter converter = attrMap.getValueConverter(oid);
-        if (converter == null) {
-            converter = new GenericValueConverter();
-            //throw new IOException("Converter not found: unsupported attribute type");
-        }
+            //get the attribute converter
+            AVAValueConverter converter = attrMap.getValueConverter(oid);
+            if (converter == null) {
+                converter = new GenericValueConverter();
+                //throw new IOException("Converter not found: unsupported attribute type");
+            }
 
-        //loop through all the values and encode
-        Enumeration<String> vals = valueSet.elements();
-        while (vals.hasMoreElements()) {
-            String val = vals.nextElement();
-            DerValue derobj = converter.getValue(val);
-            derobj.encode(tmp);
-        }
+            //loop through all the values and encode
+            Enumeration<String> vals = valueSet.elements();
+            while (vals.hasMoreElements()) {
+                String val = vals.nextElement();
+                DerValue derobj = converter.getValue(val);
+                derobj.encode(tmp);
+            }
 
-        tmp2.write(DerValue.tag_SetOf, tmp);
-        out.write(tmp2.toByteArray());
+            tmp2.write(DerValue.tag_SetOf, tmp);
+            out.write(tmp2.toByteArray());
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     //decode the attribute object
diff --git a/base/util/src/netscape/security/x509/AuthorityKeyIdentifierExtension.java b/base/util/src/netscape/security/x509/AuthorityKeyIdentifierExtension.java
index a8df9d132f120cfef4b0e901742f7c1bcd6a41b2..23552a5c88b722e83cb72a16a8b83df8ec30dfbc 100644
--- a/base/util/src/netscape/security/x509/AuthorityKeyIdentifierExtension.java
+++ b/base/util/src/netscape/security/x509/AuthorityKeyIdentifierExtension.java
@@ -83,32 +83,36 @@ public class AuthorityKeyIdentifierExtension extends Extension
 
     // Encode only the extension value
     private void encodeThis() throws IOException {
-        DerOutputStream seq = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
-        if (id != null) {
-            DerOutputStream tmp1 = new DerOutputStream();
-            id.encode(tmp1);
-            tmp.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
-                              false, TAG_ID), tmp1);
-        }
-        try {
-            if (names != null) {
+        try (DerOutputStream tmp = new DerOutputStream();
+                DerOutputStream seq = new DerOutputStream()) {
+
+            if (id != null) {
                 DerOutputStream tmp1 = new DerOutputStream();
-                names.encode(tmp1);
+                id.encode(tmp1);
                 tmp.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
-                                  true, TAG_NAMES), tmp1);
+                        false, TAG_ID), tmp1);
             }
-        } catch (Exception e) {
-            throw new IOException(e.toString());
-        }
-        if (serialNum != null) {
-            DerOutputStream tmp1 = new DerOutputStream();
-            serialNum.encode(tmp1);
-            tmp.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
-                              false, TAG_SERIAL_NUM), tmp1);
+            try {
+                if (names != null) {
+                    DerOutputStream tmp1 = new DerOutputStream();
+                    names.encode(tmp1);
+                    tmp.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
+                            true, TAG_NAMES), tmp1);
+                }
+            } catch (Exception e) {
+                throw new IOException(e.toString());
+            }
+            if (serialNum != null) {
+                DerOutputStream tmp1 = new DerOutputStream();
+                serialNum.encode(tmp1);
+                tmp.writeImplicit(DerValue.createTag(DerValue.TAG_CONTEXT,
+                        false, TAG_SERIAL_NUM), tmp1);
+            }
+            seq.write(DerValue.tag_Sequence, tmp);
+            this.extensionValue = seq.toByteArray();
+        } catch (IOException e) {
+            throw e;
         }
-        seq.write(DerValue.tag_Sequence, tmp);
-        this.extensionValue = seq.toByteArray();
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/BasicConstraintsExtension.java b/base/util/src/netscape/security/x509/BasicConstraintsExtension.java
index 8f3a3c6346b29554740f70f401300041f85fee37..001b148b1b187b2bf3e7edf32b88eaa7865e2e26 100644
--- a/base/util/src/netscape/security/x509/BasicConstraintsExtension.java
+++ b/base/util/src/netscape/security/x509/BasicConstraintsExtension.java
@@ -73,17 +73,20 @@ public class BasicConstraintsExtension extends Extension
 
     // Encode this extension value
     private void encodeThis() throws IOException {
-        DerOutputStream out = new DerOutputStream();
-        DerOutputStream tmp = new DerOutputStream();
+        try (DerOutputStream out = new DerOutputStream()) {
+            DerOutputStream tmp = new DerOutputStream();
 
-        if (ca) {
-            tmp.putBoolean(ca);
+            if (ca) {
+                tmp.putBoolean(ca);
+            }
+            if (pathLen >= 0) {
+                tmp.putInteger(new BigInt(pathLen));
+            }
+            out.write(DerValue.tag_Sequence, tmp);
+            this.extensionValue = out.toByteArray();
+        } catch (IOException e) {
+            throw e;
         }
-        if (pathLen >= 0) {
-            tmp.putInteger(new BigInt(pathLen));
-        }
-        out.write(DerValue.tag_Sequence, tmp);
-        this.extensionValue = out.toByteArray();
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/CRLNumberExtension.java b/base/util/src/netscape/security/x509/CRLNumberExtension.java
index 4cacde942cdac89236cfc1dc3d6f4e631fca6176..63289513f2f52c3e63d54164334627e130b9cead 100755
--- a/base/util/src/netscape/security/x509/CRLNumberExtension.java
+++ b/base/util/src/netscape/security/x509/CRLNumberExtension.java
@@ -61,9 +61,12 @@ public class CRLNumberExtension extends Extension
     private void encodeThis() throws IOException {
         if (crlNumber == null)
             throw new IOException("Unintialized CRL number extension");
-        DerOutputStream os = new DerOutputStream();
-        os.putInteger(this.crlNumber);
-        this.extensionValue = os.toByteArray();
+        try (DerOutputStream os = new DerOutputStream()) {
+            os.putInteger(this.crlNumber);
+            this.extensionValue = os.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/CRLReasonExtension.java b/base/util/src/netscape/security/x509/CRLReasonExtension.java
index 77339528e4b640814c7cf0dca8897b5603f049fe..59cd45d911e70b607082412fcdec5fc519052760 100644
--- a/base/util/src/netscape/security/x509/CRLReasonExtension.java
+++ b/base/util/src/netscape/security/x509/CRLReasonExtension.java
@@ -181,9 +181,12 @@ public final class CRLReasonExtension extends Extension implements CertAttrSet {
     private void encodeThis() throws IOException {
         if (mReason == null)
             throw new IOException("Unintialized CRLReason extension");
-        DerOutputStream os = new DerOutputStream();
-        os.putEnumerated(mReason.toInt());
-        this.extensionValue = os.toByteArray();
+        try (DerOutputStream os = new DerOutputStream()) {
+            os.putEnumerated(mReason.toInt());
+            this.extensionValue = os.toByteArray();
+        } catch (IOException e) {
+            throw e;
+        }
     }
 
     /**
diff --git a/base/util/src/netscape/security/x509/CertificateExtensions.java b/base/util/src/netscape/security/x509/CertificateExtensions.java
index 5fdac282426772c9d21abc3982c59a1e788f7ca0..e8cd5bfb443f3c227e0399e6e80bfb84a4175bb4 100644
--- a/base/util/src/netscape/security/x509/CertificateExtensions.java
+++ b/base/util/src/netscape/security/x509/CertificateExtensions.java
@@ -187,25 +187,28 @@ public class CertificateExtensions extends Vector<Extension>
      */
     public void encode(OutputStream out)
             throws CertificateException, IOException {
-        DerOutputStream extOut = new DerOutputStream();
-        for (int i = 0; i < size(); i++) {
-            Object thisOne = elementAt(i);
-            if (thisOne instanceof CertAttrSet)
-                ((CertAttrSet) thisOne).encode(extOut);
-            else if (thisOne instanceof Extension)
-                ((Extension) thisOne).encode(extOut);
-            else
-                throw new CertificateException("Invalid extension object");
+        try (DerOutputStream tmp = new DerOutputStream()) {
+            DerOutputStream extOut = new DerOutputStream();
+            for (int i = 0; i < size(); i++) {
+                Object thisOne = elementAt(i);
+                if (thisOne instanceof CertAttrSet)
+                    ((CertAttrSet) thisOne).encode(extOut);
+                else if (thisOne instanceof Extension)
+                    ((Extension) thisOne).encode(extOut);
+                else
+                    throw new CertificateException("Invalid extension object");
+            }
+
+            DerOutputStream seq = new DerOutputStream();
+            seq.write(DerValue.tag_Sequence, extOut);
+
+            tmp.write(DerValue.createTag(DerValue.TAG_CONTEXT, true, (byte) 3),
+                    seq);
+
+            out.write(tmp.toByteArray());
+        } catch (IOException | CertificateException e) {
+            throw e;
         }
-
-        DerOutputStream seq = new DerOutputStream();
-        seq.write(DerValue.tag_Sequence, extOut);
-
-        DerOutputStream tmp = new DerOutputStream();
-        tmp.write(DerValue.createTag(DerValue.TAG_CONTEXT, true, (byte) 3),
-                  seq);
-
-        out.write(tmp.toByteArray());
     }
 
     /**
